Resource = function(key, path) {
	var that = {};
	that.payload = undefined;
	that.path = path;
	that.key = key;
	that.ready = false;
	that.state = "idle";
	that.error = undefined;
	
	that.free = function() {};
	
	return that;
}

RessourceLoader = function(base) {

	/*
	if(!Zinedine.isInitialized()) {
		Zinedine.noAPIError();
		return undefined;
	};
	*/

	var that = {};
	base = base || "";
	that.base = base;
	that.status = "ready";
	
	that.freeAll = function() {
		that.free(that.staticList);
		that.free(that.localList);
		
		that.staticList = [];
		that.localList = [];
		that.todoList = [];
		
		that.sfx = [];
		that.img = [];
	};
	
	that.free = function(list) {
		if(list != undefined) {
			for(var i = 0; i < list.length; i++) {
				list[i].free();
			}
		}
	};

	that.freeAll();
	
	that.load = function(where, dict, finishFunc, updateFunc, errorFunc) {
		var list;
		
		finishFunc = finishFunc || function() {}
		updateFunc = updateFunc || function(item, res) {}
		errorFunc = errorFunc || function(item, res) {}
		
		if(where == "static") {
			that.free(that.staticList);
			list = that.staticList;
			that.staticList = [];
		} else {
			that.free(that.localList);
			list = that.localList;
			that.localList = [];
		}
		
		var realUpdateFunc = function(res) {
			updateFunc(res, that);
			if(that.todoList.length == 0) {
				finishFunc();	
			}
		}

		var realErrorFunc = function(res) {
			if(res.error != undefined) {
				console.log(res.error);
			}
			errorFunc(res, that);
		}
				
		var sfxList = dict.sfx;
		if(sfxList) {
			for(var i = 0; i < sfxList.length; i++) {
				that.loadSFX(sfxList[i][0], base + sfxList[i][1], sfxList[i][2], list, realUpdateFunc, realErrorFunc);
			}
		}

		var imgList = dict.img;
		if(imgList) {
			for(var i = 0; i < imgList.length; i++) {
				var doFlip = imgList[i][3];
				var rescale = imgList[i][2];
				that.loadImg(imgList[i][0], base + imgList[i][1], rescale, doFlip, list, realUpdateFunc, realErrorFunc);
			}
		}

		// nothing to load, let's go!
		if(that.todoList.length == 0) {
			finishFunc(that);
		}
	};
	
	var moveToList = function(object, list) {
		for(var i = 0; i < that.todoList.length; i++) {
			if(object === that.todoList[i]) {
				that.todoList.splice(i, 1);
				list.push(object);
				return;
			}
		}
	};

	that.loadImg = function(key, path, rescale, doFlip, targetList, updateFunc, errorFunc) {
		var img = new Image();
		var result = Resource(key, path);

		that.todoList.push(result);
		
		img.onload = function() {
			result.payload = img;
			result.ready = true;
			result.state = "ready";
			moveToList(result, targetList);
			that.img[key] = result.payload;

			updateFunc(result);
		};

		img.onerror = function(e) {
			result.error = "Could not load image '" + result.path + "'";
			errorFunc(result);
		};

		try {
			img.src = path;
		} catch (e) {
			result.error = "Could not load image '" + result.path + "'";
			errorFunc(result);
		}
	};

	that.loadSFX = function(key, path, volume, targetList, updateFunc, errorFunc) {
		var audio = new Audio();
		audio.volume = volume;
		audio.preload = true;
		var result = Resource(key, path);

		that.todoList.push(result);

		audio.addEventListener('loadeddata', function() {
			result.payload = audio;
			result.ready = true;
			result.state = "ready";
			moveToList(result, targetList);
			that.sfx[key] = result.payload;

			audio.bleep = function() {
				audio.currentTime = 0;
				audio.play();
			}

			updateFunc(result);
		});

		audio.onerror = function(e) {
			result.error = "Could not load audio '" + result.path + "'";
			errorFunc(result);
		};

		try {
			audio.src = path;
		} catch (e) {
			result.error = "Could not load audio '" + result.path + "'";
			errorFunc(result);
		}
	};
	
	that.elementsToLoad = function() {
		return that.todoList.length;
	};
	
	return that;
};